//var serverUrl = 'http://192.168.0.13:9999/';

//var serverUrl = 'http://192.168.2.38:9999/';

var serverUrl = 'http://www.hkbtv.cn:9999/';

var devServerUrl = "";

var ASE_SUFFIX = "HKBTV";

function aecEnc(key, message) {
	console.log(key);
	console.log(message);
	var md5key = CryptoJS.MD5(key + ASE_SUFFIX).toString().toUpperCase();
	var subKey = md5key.substring(0, 14) + "==";
	console.log(subKey);

	var key = CryptoJS.enc.Utf8.parse(subKey);
	var iv = CryptoJS.enc.Utf8.parse(subKey);
	var srcs = CryptoJS.enc.Utf8.parse(message);
	var encrypted = CryptoJS.AES.encrypt(srcs, key, {
		iv : iv,
		mode : CryptoJS.mode.CBC
	});
	
	console.log(encrypted.toString());
	
	return encrypted.toString();
}

function ajaxRequest(url, method, datas, callBack,timestamp) {

	var signature__,timestamp__;
	
	timestamp__ = Date.now();

	var userinfo;
	var jsonstr = $api.getStorage('userinfo');
	if(jsonstr){
		userinfo = JSON.parse(jsonstr);
	}else{
		userinfo = {};
	}
	
	signature__ = aecEnc(timestamp__,userinfo.userid);
	datas["timestamp__"] = timestamp__;
	datas["signature__"] = signature__;

	//获取设备号码
	var deviceId = api.deviceId;
	
	datas["deviceId"] = deviceId;
	datas["userid"] = userinfo.userid;
	datas["token"] = userinfo.token;
	
	var now = Date.now();
	var token = datas["token"];
	if (timestamp) {
		datas["timestamp"] = now;
	}else{
		datas["timestamp"] = now;
	}
	
	
	if (token != undefined) {
		//datas["token"] = aecEnc(now, token);
	}

	//datas["imei"] = aecEnc(now, api.deviceId);

	console.log(serverUrl + url + ";" + method + " params:" + JSON.stringify(datas));
	api.ajax({
		url : serverUrl + url,
		method : method,
		cache : false,
		timeout : 120,
		dataType : 'text',
		data : {
			values : datas
		}
	}, function(ret, err) {
		console.log(serverUrl + url + ";" + method + " result:" + JSON.stringify(ret));
		if (err){
			console.log(JSON.stringify(err));
		}
		callBack(ret, err);
	});
}

/**
 *更新用户信息 
 */
function common_updateUserInfo(datas){
	var url = "/app/user/updateUserInfo";
	ajaxRequest(url,"POST",datas,function(data){
		var json = JSON.parse(data);
		updateUserInfo(json.data);
		
		//发送事件，更新用户信息
		api.sendEvent({
		    name: 'event_update_user_info'
		});
		
		
		api.toast({
		    msg: json.msg,
		    duration: 2000,
		    location: 'middle'
		});
	})
}

/**
 *添加收藏 
 */
function addFavorite(model,modelId,callback){
	var url ="/app/user/addFavorite";
	var datas ={};
	datas["model"] = model;
	datas["modelId"] = modelId;
	ajaxRequest(url, "POST", datas, callback)
}

/**
 *删除收藏 
 */
function removeFavorite(id,callback){
	var url ="/app/user/removeFavorite/"+id;
	var datas ={};
	ajaxRequest(url, "GET", datas, callback)
}

function openUrl(url,title){
	api.openWin({
	    name: title,
	    url: url
    });
}

function openServerPage(url,title){

	var signature__,timestamp__;
	
	timestamp__ = Date.now();

	var userinfo;
	var jsonstr = $api.getStorage('userinfo');
	if(jsonstr){
		userinfo = JSON.parse(jsonstr);
	}else{
		userinfo = {};
	}
	
	signature__ = aecEnc(timestamp__,userinfo.userid);
	
	var deviceId = api.deviceId;
	var token = userinfo.token;
	
	console.log(JSON.stringify(userinfo));
	
	var targetUrl = serverUrl+url;
	if(targetUrl.indexOf("?")!=-1){
		targetUrl = targetUrl+"&deviceId="+deviceId+"&token="+token+"&timestamp__="+timestamp__+"&signature__="+signature__;
	}else{
		targetUrl = targetUrl+"?deviceId="+deviceId+"&token="+token+"&timestamp__="+timestamp__+"&signature__="+signature__;
	}
	
	console.log(targetUrl);
	
	api.openWin({
	    name: title,
	    url: targetUrl
    });
}
/**
 *显示文章页面 
 */
function showArticle(id,title){
	api.openWin({
	    name: title,
	    url: "hkbtv_news_win.html",
	    pageParam:{
	    	id:id,
	    	title:title
	    }
    });
}

/*
 * 显示维权信息
 */
function showPostDetail(id){
	api.openWin({
	    name: "维权",
	    url: "hkbtv_weiquan_detail_win.html",
	    pageParam:{
	    	id:id
	    }
    });
}

function showLoading(time) {
	var body = $api.dom("body");
	var loading = $api.byId("loading");
	if (!loading) {
		$api.append(body, '<div class="aui-loading" id="loading"></div>');
		if (time && time > 0) {
			//如果有时间传进来就定时隐藏
			$api.remove(loading);
		}
	}

}

function hideLoading() {
	var loading = $api.byId("loading");
	setTimeout(function() {
		$api.remove(loading);
	}, 500);

}

function formatDate(time) {
	//var newTime = time.substring(0,10);
	var date = new Date(time * 1000);
	var hour = date.getHours();
	var minute = date.getMinutes();
	var second = date.getSeconds();
	return hour + ':' + minute;
}

/**
 * 选取图片
 */
function getPicture(object) {
	object = object ? object : {};
	api.actionSheet({
		title : '请选择图片来源',
		cancelTitle : '取消',
		buttons : ['拍摄照片', '相册选取']
	}, function(ret, err) {
		var prictureParams = {
			sourceType : 'library',
			encodingType : 'jpg',
			mediaValue : 'pic',
			destinationType : 'url',
			allowEdit : true,
			quality : 100,
		}
		if (ret.buttonIndex == 1) {
			prictureParams.sourceType='camera';
		}
		api.getPicture(prictureParams, function(ret, err) {
			object.imgPath = ret.data;
			if (ret.data) {
				var toolDom = $api.byId('imageclipTool');
				$api.css(toolDom, 'display:block');
				api.openWin({
					name : 'imageclip_win',
					url : 'imageclip_win.html',
					bounces : false,
					delay : 300,
					pageParam : object
				});
			}
		});
	});
}


function getPictureNoCut(object,sendEvent) {
	object = object ? object : {};
	api.actionSheet({
		title : '请选择图片来源',
		cancelTitle : '取消',
		buttons : ['拍摄照片', '相册选取']
	}, function(ret, err) {
		var prictureParams = {
			sourceType : 'library',
			encodingType : 'jpg',
			mediaValue : 'pic',
			destinationType : 'url',
			allowEdit : true,
			quality : 100,
		}
		if (ret.buttonIndex == 1) {
			prictureParams.sourceType='camera';
		}
		api.getPicture(prictureParams, function(ret, err) {
			object.imgPath = ret.data;
			if (ret.data) {
				uploadImg(ret.data, {}, function(data) {
					if (sendEvent != null) {
					}
					//发送事件，调用页面刷新
					api.sendEvent({
						name : sendEvent,
						extra : data
					});
				})
			
			
			}
		});
	});
}

/***
 *上传图片
 */
function uploadPic(filePath, datas, callback) {
	var now = Date.now();

	api.showProgress({
		style : 'default',
		animationType : 'fade',
		title : '图片上传中...',
		text : '请稍后',
		modal : false
	});

	var token = datas["token"];
	var timestamp = datas["timestamp"];
	if (timestamp == undefined) {
		datas["timestamp"] = now;
	}

	if (token != undefined) {
		//datas["token"] = aecEnc(now, token);
	}

	var uploadUrl = serverUrl + "/app/uploadImgBase64/0";
	console.log("uploadPic url" + uploadUrl);
	api.ajax({
		url : uploadUrl,
		method : "POST",
		cache : false,
		timeout : 120,
		dataType : 'json',
		data : {
			values : datas,
			files : {
				uploadFile : filePath
			}
		}
	}, function(ret2, err2) {
		api.hideProgress();
		console.log("upload result:" + JSON.stringify(ret2.data));
		if (ret2) {
			callback(ret2.data);
		} else {
			$api.toast("", "上传失败，请稍后再试！", 2000);
		}
	});
}

/**
 *上传图片，返回图片路径 
 * @param {Object} filePath
 * @param {Object} datas
 * @param {Object} callback
 */
function uploadImg(filePath, datas, callback) {
	var now = Date.now();

	api.showProgress({
		style : 'default',
		animationType : 'fade',
		title : '图片上传中...',
		text : '请稍后',
		modal : false
	});

	var token = datas["token"];
	var timestamp = datas["timestamp"];
	if (timestamp == undefined) {
		datas["timestamp"] = now;
	}

	if (token != undefined) {
		//datas["token"] = aecEnc(now, token);
	}

	var uploadUrl = serverUrl + "/app/uploadImg";
	api.ajax({
		url : uploadUrl,
		method : "POST",
		cache : false,
		timeout : 120,
		dataType : 'json',
		data : {
			values : datas,
			files : {
				uploadFile : filePath
			}
		}
	}, function(ret2, err2) {
		api.hideProgress();
		console.log("upload result:" + JSON.stringify(ret2.data));
		if (ret2) {
			callback(ret2.data);
		} else {
			$api.toast("", "上传失败，请稍后再试！", 2000);
		}
	});
}

function ajaxLoadDataError() {
	api.toast({
		msg : '获取数据失败',
		duration : 2000
	});
}


function openBroser(url,title){
		api.openWin({
	        name: "hkbtv_browser_win",
	        url: "hkbtv_browser_win.html",
	        pageParam:{
	        	url:url,
	        	title:title
	        }
        });
        
        return;
       
		  if (api.systemType =="android"){
                api.openApp({
                iosUrl: url,
                androidPkg: 'android.intent.action.VIEW',
                mimeType: 'text/html',
                uri: url
            }, function (ret2, err2) {
                        if(ret2){
                                
                        }else{
                                alert('请安装“百度、搜狗或者猎豹”手机浏览器打开');
                        }
            });
        }else{
            api.openApp({
                    iosUrl: url,
                    appParam: {'appParam': ''}
                },function(ret2,err2){
                    if(ret2){
                                
                        }else{
                                alert('打开失败');
                        }
                });
        }
}


function transJsTimestamp(timestamp, isShowTime) {
    var datetime = new Date(timestamp);
    return getNowDateFormat('-', ':', isShowTime, datetime);
}

function getNowDateFormat(dateSeparator, timeSeparator, isShowTime, datetime) {
    dateSeparator = isNullOrEmpty(dateSeparator) ? "-" : dateSeparator;
    timeSeparator = isNullOrEmpty(timeSeparator) ? ":" : timeSeparator;
    isShowTime = isTargetType(arguments[2], "boolean") ? arguments[2] : true;

    var now = datetime ? datetime : new Date();
    var year = now.getFullYear();
    var month = now.getMonth() + 1;
    var date = now.getDate();
    var hours = now.getHours();
    var minutes = now.getMinutes();
    var seconds = now.getSeconds();

    if (month >= 1 && month <= 9) {
        month = "0" + month;
    }
    if (date >= 0 && date <= 9) {
        date = "0" + date;
    }
    var _date = year + dateSeparator + month + dateSeparator + date;
    var _time = hours + timeSeparator + minutes + timeSeparator + seconds;

    return isShowTime ? (_date + " " + _time) : _date;
}

function isTargetType (obj, typeString) {
    return typeof obj === typeString;
}

function isNullOrEmpty (str) {
    return (str == null || str == undefined || $.trim(str) == "") ? true : false;
}

function common_formatBytes(size){
	var str = "";
 	if(size >= 1073741824) {
        str = Math.round(size / 1073741824 * 100) / 100 + 'GB';
    } else if(size >= 1048576) {
        str = Math.round(size / 1048576 * 100) / 100 + 'MB';
    } else if(size >= 1024) {
        str = Math.round(size / 1024 * 100) / 100 + 'KB';
    } else {
        str = size + 'Bytes';
    }
    return str;
}


/**
 *微信分享 
 * params:{title,description,thumb,contentUrl}
 */
function common_wx_shareWebpage(params,callback){

	var dialogBox = api.require('dialogBox');
	var wx = api.require('wx');
 	
 	wx.isInstalled(function(ret, err){
	    if(ret.installed){
	    
	    	dialogBox.share({
		    rect:{
		        w: 300,
		        h: 300
		    },
		    items:[
		    {
		        text: '微信好友',
		        icon: 'widget://image/icon/wx_logo.png'
		    },
		    {
		        text: '朋友圈',
		        icon: 'widget://image/icon/wx_moments.png'
		    },
		    {
		        text: '微信收藏',
		        icon: 'widget://image/icon/wx_collect.png'
		    },
		    ],
		    styles:{
		        bg:'#FFF',
		        column: 3,
		        horizontalSpace : 15,
		        verticalSpace : 30,
		        itemText: {
		            color: '#000',
		            size: 15,
		            marginT: 10
		        },
		        itemIcon:{
		            size:64
		        }
		    },
		    tapClose:true
		}, function(ret){
		
		    var types = ['session','timeline','favorite'];
		    var type_ = types[ret.index];
		    dialogBox.close();
		    
		    //获取文章图片
	    	if(params['thumbnails'] != ''){
		    	api.imageCache({
				    url: params['thumbnails']
				}, function(ret, err) {
				
				    var url = ret.url;
				    
				    wx.shareWebpage({
					    apiKey: '',
					    scene: type_,
					    title: params['title'],
					    description: params['description'],
					    thumb: url,
					    contentUrl: params['contentUrl']
					},function(ret, err){
					    if(ret.status){
					    	api.toast({
                                msg:'分享成功'
                            });
					    }else{
					    	api.toast({
                                msg:"分享失败，错误码："+err.code
                            });
					    }
					});
					
				});
	    	}else{
	    		
			    wx.shareWebpage({
				    apiKey: '',
				    scene: type_,
				    title: params['title'],
				    description: params['description'],
                    thumb: 'http://www.hkbtv.cn/ihk/images/wecharnew.png',
				    contentUrl: params['contentUrl']
				}, function(ret, err){
				    if(ret.status){
					    	api.toast({
                                msg:'分享成功'
                            });
					    }else{
					    	api.toast({
                                msg:"分享失败，错误码："+err.code
                            });
					    }
				});
			    
	    	}
	    	
		    
		});
			
	    }else{
	        alert('当前设备未安装微信客户端');
	    }
	});
 	
}